OpenShot Audio Library | OpenShotAudio: juce::LocalisedStrings Class Reference

OpenShot Audio Library | OpenShotAudio 0.6.0

Loading...
Searching...
No Matches
juce::LocalisedStrings Class Reference

`#include <juce_LocalisedStrings.h>`

## Public Member Functions
| LocalisedStrings (const String &fileContents, bool ignoreCaseOfKeys)
| LocalisedStrings (const File &fileToLoad, bool ignoreCaseOfKeys)
| LocalisedStrings (const LocalisedStrings &)
LocalisedStrings & | operator= (const LocalisedStrings &)
| ~LocalisedStrings ()=default
String | translate (const String &text) const
String | translate (const String &text, const String &resultIfNotFound) const
String | getLanguageName () const
const StringArray & | getCountryCodes () const
const StringPairArray & | getMappings () const
void | addStrings (const LocalisedStrings &)
void | setFallback (LocalisedStrings *fallbackStrings)

## Static Public Member Functions
static void | setCurrentMappings (LocalisedStrings *newTranslations)
static LocalisedStrings * | getCurrentMappings ()
static String | translateWithCurrentMappings (const String &text)
static String | translateWithCurrentMappings (const char *text)

## Detailed Description

Used to convert strings to localised foreign-language versions.

This is basically a look-up table of strings and their translated equivalents. It can be loaded from a text file, so that you can supply a set of localised versions of strings that you use in your app.

To use it in your code, simply call the translate() method on each string that might have foreign versions, and if none is found, the method will just return the original string.

The translation file should start with some lines specifying a description of the language it contains, and also a list of ISO country codes where it might be appropriate to use the file. After that, each line of the file should contain a pair of quoted strings with an '=' sign.

E.g. for a french translation, the file might be:

language: French
countries: fr be mc ch lu
"hello" = "bonjour"
"goodbye" = "au revoir"

If the strings need to contain a quote character, they can use " instead, and if the first non-whitespace character on a line isn't a quote, then it's ignored, (you can use this to add comments).

Note that this is a singleton class, so don't create or destroy the object directly. There's also a TRANS (text) macro defined to make it easy to use the this.

printSomething (TRANS ("hello"));

This macro is used in the JUCE classes themselves, so your application has a chance to intercept and translate any internal JUCE text strings that might be shown. (You can easily get a list of all the messages by searching for the TRANS() macro in the JUCE source code).

Definition at line 71 of file juce_LocalisedStrings.h.

## Constructor & Destructor Documentation

## ◆ LocalisedStrings() [1/3]

juce::LocalisedStrings::LocalisedStrings | ( | const String & | fileContents,
|  | bool | ignoreCaseOfKeys )

Creates a set of translations from the text of a translation file.

When you create one of these, you can call setCurrentMappings() to make it the set of mappings that the system's using.

Definition at line 26 of file juce_LocalisedStrings.cpp.

Referenced by addStrings(), getCurrentMappings(), setCurrentMappings(), setFallback(), and ~LocalisedStrings().

## ◆ LocalisedStrings() [2/3]

juce::LocalisedStrings::LocalisedStrings | ( | const File & | fileToLoad,
|  | bool | ignoreCaseOfKeys )

Creates a set of translations from a file.

When you create one of these, you can call setCurrentMappings() to make it the set of mappings that the system's using.

Definition at line 31 of file juce_LocalisedStrings.cpp.

## ◆ LocalisedStrings() [3/3]

juce::LocalisedStrings::LocalisedStrings | ( | const LocalisedStrings & | other | ) |

Definition at line 36 of file juce_LocalisedStrings.cpp.

## ◆ ~LocalisedStrings()

juce::LocalisedStrings::~LocalisedStrings | ( |  | ) |
| default

Destructor.

## Member Function Documentation

## ◆ addStrings()

void juce::LocalisedStrings::addStrings | ( | const LocalisedStrings & | other | ) |

Adds and merges another set of translations into this set.

Note that the language name and country codes of the new LocalisedStrings object must match that of this object - an assertion will be thrown if they don't match.

Any existing values will have their mappings overwritten by the new ones.

Definition at line 160 of file juce_LocalisedStrings.cpp.

## ◆ getCountryCodes()

const StringArray & juce::LocalisedStrings::getCountryCodes | ( |  | ) | const
| inline

Returns the list of suitable country codes listed in the translation file.

These is specified in the file using a line starting with "countries:", e.g.

countries: fr be mc ch lu

The country codes are supposed to be 2-character ISO compliant codes.

Definition at line 166 of file juce_LocalisedStrings.h.

## ◆ getCurrentMappings()

LocalisedStrings * juce::LocalisedStrings::getCurrentMappings | ( |  | ) |
| static

Returns the currently selected set of mappings.

This is the object that was last passed to setCurrentMappings(). It may be nullptr if none has been created.

Definition at line 180 of file juce_LocalisedStrings.cpp.

Referenced by ~LocalisedStrings().

## ◆ getLanguageName()

String juce::LocalisedStrings::getLanguageName | ( |  | ) | const
| inline

Returns the name of the language specified in the translation file.

This is specified in the file using a line starting with "language:", e.g.

language: german

Definition at line 155 of file juce_LocalisedStrings.h.

## ◆ getMappings()

const StringPairArray & juce::LocalisedStrings::getMappings | ( |  | ) | const
| inline

Provides access to the actual list of mappings.

Definition at line 169 of file juce_LocalisedStrings.h.

## ◆ operator=()

LocalisedStrings & juce::LocalisedStrings::operator= | ( | const LocalisedStrings & | other | ) |

Definition at line 42 of file juce_LocalisedStrings.cpp.

## ◆ setCurrentMappings()

void juce::LocalisedStrings::setCurrentMappings | ( | LocalisedStrings * | newTranslations | ) |
| static

Selects the current set of mappings to be used by the system.

The object you pass in will be automatically deleted when no longer needed, so don't keep a pointer to it. You can also pass in nullptr to remove the current mappings.

See also the TRANS() macro, which uses the current set to do its translation.

See also
  translateWithCurrentMappings

Definition at line 174 of file juce_LocalisedStrings.cpp.

Referenced by ~LocalisedStrings().

## ◆ setFallback()

void juce::LocalisedStrings::setFallback | ( | LocalisedStrings * | fallbackStrings | ) |

Gives this object a set of strings to use as a fallback if a string isn't found. The object that is passed-in will be owned and deleted by this object when no longer needed. It can be nullptr to clear the existing fallback object.

Definition at line 168 of file juce_LocalisedStrings.cpp.

## ◆ translate() [1/2]

String juce::LocalisedStrings::translate | ( | const String & | text | ) | const

Attempts to look up a string and return its localised version. If the string isn't found in the list, the original string will be returned.

Definition at line 52 of file juce_LocalisedStrings.cpp.

Referenced by ~LocalisedStrings().

## ◆ translate() [2/2]

String juce::LocalisedStrings::translate | ( | const String & | text,
|  | const String & | resultIfNotFound ) const

Attempts to look up a string and return its localised version. If the string isn't found in the list, the resultIfNotFound string will be returned.

Definition at line 60 of file juce_LocalisedStrings.cpp.

## ◆ translateWithCurrentMappings() [1/2]

String juce::LocalisedStrings::translateWithCurrentMappings | ( | const char * | text | ) |
| static

Tries to translate a string using the currently selected set of mappings.

If no mapping has been set, or if the mapping doesn't contain a translation for the string, this will just return the original string.

See also the TRANS() macro, which uses this method to do its translation.

See also
  setCurrentMappings, getCurrentMappings

Definition at line 186 of file juce_LocalisedStrings.cpp.

## ◆ translateWithCurrentMappings() [2/2]

String juce::LocalisedStrings::translateWithCurrentMappings | ( | const String & | text | ) |
| static

Tries to translate a string using the currently selected set of mappings.

If no mapping has been set, or if the mapping doesn't contain a translation for the string, this will just return the original string.

See also the TRANS() macro, which uses this method to do its translation.

See also
  setCurrentMappings, getCurrentMappings

Definition at line 185 of file juce_LocalisedStrings.cpp.

Referenced by ~LocalisedStrings().

The documentation for this class was generated from the following files:

- juce_LocalisedStrings.h
- juce_LocalisedStrings.cpp